var _excluded = ["portal", "overflowContainer", "indexs"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useRef, useImperativeHandle, useEffect, Fragment } from 'react';
import Instance from './instance.js';
import { createPortal } from 'react-dom';
var IndexBar = forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
      overflowContainer = _ref.overflowContainer,
      _ref$indexs = _ref.indexs,
      indexs = _ref$indexs === void 0 ? ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'G', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'] : _ref$indexs,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var barRef = useRef(null);
  var toolTipRef = useRef(null);
  useImperativeHandle(ref, function () {
    return barRef.current;
  });
  var instance = useRef(null);
  useEffect(function () {
    instance.current = new Instance({
      overflowContainer: overflowContainer || barRef.current.parentNode,
      parent: portal || barRef.current.parentNode,
      bar: barRef.current,
      tooltip: toolTipRef.current
    });
  }, []); // eslint-disable-line

  var DOM = /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("div", _extends({
    ref: barRef
  }, others, {
    className: "indexbar" + (others.className ? ' ' + others.className : '')
  }), indexs.map(function (index, i) {
    return /*#__PURE__*/React.createElement("span", {
      className: "indexbar-button",
      key: "btn" + i
    }, index);
  })), /*#__PURE__*/React.createElement("div", {
    ref: toolTipRef,
    className: "indexbar-tooltip"
  }));

  if (portal) {
    return createPortal(DOM, portal);
  }

  return DOM;
});
export default IndexBar;